
#include "inc.h"

#include "lib.h"
#include "printf.h"
#include "iwram_arm.h"
#include "div_arm.h"

#include "main.h"


//Mode3
//SPR J[\

//---------------------------------------------------------------------------
//lib.c
extern ST_TIMER Timer;

//---------------------------------------------------------------------------

u8 State;						//is󋵃tO
//---------------------------------------------------------------------------
EWRAM_CODE int main()
{
	State = STATE_INIT;

	for(;;)
	{
		switch(State)
		{
			case STATE_INIT:  StateInit();  break;
			case STATE_RESET: StateReset(); break;
			case STATE_GAME:  StateGame();  break;

			default:
				DebugMessage("Err: Main State");
				break;
		}
	}

	return 0;
}
//---------------------------------------------------------------------------
EWRAM_CODE void StateInit()
{
	InitWS();
	InitKey();
	InitSprite();
	InitIRQ();

	SetMode(MODE_3 | BG2_ENABLE | OBJ_ENABLE | OBJ_MAP_2D);
	State = STATE_RESET;
}
//---------------------------------------------------------------------------
EWRAM_CODE void InitWS()
{
	//J[hbW̕Wݒ
	REG_WSCNT = 0x4317;
}
//---------------------------------------------------------------------------
EWRAM_CODE void InitKey()
{
	KeyInit();
}
//---------------------------------------------------------------------------
EWRAM_CODE void InitSprite()
{
	SpriteInit();

	SpriteSetPalData16((u16*)&spr_pal_bin);
	SpriteSetData ((u16*)&spr_img_bin, SPR_IMG_BYTE);
}
//---------------------------------------------------------------------------
EWRAM_CODE void InitIRQ()
{
	REG_INTERUPT = (u32)IRQUserHandler;
	REG_IE       = IRQ_BIT_TIMER0;

	REG_TM0D     = 65536 - 2621;			// (((16*1024*1024) / 64) * 10) / 1000
	REG_TM0CNT   = TM_ENABLE | TM_FREQ_PER_64 | TM_USEIRQ;

	REG_IME      = IRQ_MASTER_ON;
}
//---------------------------------------------------------------------------
EWRAM_CODE void StateReset()
{
	Mode3DrawCircle(20, 20, 10, RGB(31,31,31));
	Mode3DrawLine(0, 0, 240, 160, RGB(31,31,31));
	Mode3DrawBox(64, 64, 32, 32, RGB(31, 0, 0));

	Mode3SetFont((u8*)&shnm8x16a_img_bin, SHNM_8X16A_IMG_CX, SHNM_8X16A_FONT_CX, SHNM_8X16A_FONT_CY,
	             (u16*)&shnm_fnt_bin, SHNM_FNT_FONT_CNT);

	Mode3DrawFontStr(0, 0, (u8*)"ABCDEF123#!$", RGB(31,31,31));

	_Printf("TEST1 %d %x %x %c \n", (u8)128, (u16)128, (u32)0x12345678, (u8)'A');
	_Printf("TEST2 %010d \n", 10000);
	_Printf("TEST3 %s% d \n", "ISO", 9001);
	_Printf("TEST4 %#x \n" , 255);
	_Printf("TEST5 %5.3d \n" , 1);

	State = STATE_GAME;
}
//---------------------------------------------------------------------------
EWRAM_CODE void StateGame()
{
	WaitForVsync();
}
