
#ifndef PRINTF_H
#define PRINTF_H
#ifdef __cplusplus
extern "C" {
#endif


typedef char* va_list;

#define __vasz(x)				((sizeof(x)+sizeof(int)-1) & ~(sizeof(int) -1))

#define va_start(ap, parmN)		((ap) = (va_list)&parmN + __vasz(parmN))
#define va_arg(ap, type)		(*((type *)((va_list)((ap) = (void *)((va_list)(ap) + __vasz(type))) - __vasz(type))))
#define va_end(ap)				
#define toupper(c)				(c + ('A' - 'a'))


#define FL_LJUST        0x0001          /* left-justify field */
#define FL_SIGN         0x0002          /* sign in signed conversions */
#define FL_SPACE        0x0004          /* space in signed conversions */
#define FL_ALT          0x0008          /* alternate form */
#define FL_ZEROFILL     0x0010          /* fill with zero's */
#define FL_SHORT        0x0020          /* optional h */
#define FL_LONG         0x0040          /* optional l */
#define FL_LONGDOUBLE   0x0080          /* optional L */
#define FL_WIDTHSPEC    0x0100          /* field width is specified */
#define FL_PRECSPEC     0x0200          /* precision is specified */
#define FL_SIGNEDCONV   0x0400          /* may contain a sign */
#define FL_NOASSIGN     0x0800          /* do not assign (in scanf) */
#define FL_NOMORE       0x1000          /* all flags collected */

#define	EOF				(-1)

EWRAM_CODE void  _Puts(char* str);
EWRAM_CODE int   _Putc(char c);

EWRAM_CODE int   _Printf(char* format, ...);
EWRAM_CODE int   _DoPrnt(char* fmt, va_list ap);
EWRAM_CODE char* _O_print(va_list* ap, int flags, char* s, char c, int precision, int is_signed);

EWRAM_CODE char* _Gnum(char* f, int* ip, va_list* app);
EWRAM_CODE char* _I_compute(unsigned long val, int base, char* s, int nrdigits);



#ifdef __cplusplus
}
#endif
#endif

